//1. Go fullscreen
//2. Take drugs now
//precision highp float;

uniform float elapsedTime;
uniform vec2 resolution;
uniform bool wrap;
uniform float val0;
uniform float val1;
uniform float val2;
uniform float val3;
uniform float val4;
uniform float alpha;

//varying vec2 uvV;
//varying vec3 n;




varying vec3 position, normal;

varying float randomOffset;
//iq noise fn

#define MAX_ITER 10

#define ptpi 1385.4557313670110891409199368797 //powten(pi)
#define pipi  36.462159607207911770990826022692 //pi pied, pi^pi
#define picu  31.006276680299820175476315067101 //pi cubed, pi^3
#define pepi  23.140692632779269005729086367949 //powe(pi);
#define chpi  11.59195327552152062775175205256  //cosh(pi)
#define shpi  11.548739357257748377977334315388 //sinh(pi)
#define pisq  9.8696044010893586188344909998762 //pi squared, pi^2
#define twpi  6.283185307179586476925286766559  //two pi, 2*pi 
#define pi    3.1415926535897932384626433832795 //pi
#define e     2.7182818284590452353602874713526 //eulers number
#define sqpi  1.7724538509055160272981674833411 //square root of pi 
#define phi   1.6180339887498948482045868343656 //golden ratio
#define hfpi  1.5707963267948966192313216916398 //half pi, 1/pi
#define cupi  1.4645918875615232630201425272638 //cube root of pi
#define prpi  1.4396194958475906883364908049738 //pi root of pi
#define lnpi  1.1447298858494001741434273513531 //logn(pi); 
#define trpi  1.0471975511965977461542144610932 //one third of pi, pi/3 
#define thpi  0.99627207622074994426469058001254//tanh(pi)
#define lgpi  0.4971498726941338543512682882909 //log(pi)       
#define rcpi  0.31830988618379067153776752674503// reciprocal of pi  , 1/pi  
#define rcpipi  0.0274256931232981061195562708591 // reciprocal of pipi  , 1/pipi 

float tt = 0.0;//((elapsedTime));
float t = pi;//(rcpi*(pi+tt/pisq))+pepi;
float k = pi;//(lgpi*(pi+tt/chpi))+chpi*val2;

vec3 qAxis = normalize(vec3(sin(t*(prpi)), cos(k*(cupi)), cos(k*(hfpi)) ));
vec3 wAxis = normalize(vec3(cos(k*(-trpi)/pi), sin(t*(rcpi)/pi), sin(k*(lgpi)/pi) ));
vec3 sAxis = normalize(vec3(cos(t*(trpi)), sin(t*(-rcpi)), sin(k*(lgpi)) ));
vec3 oAxis = normalize(vec3(pi, pi, 1.0 ));
float axe = exp(qAxis.x+qAxis.y+qAxis.z+wAxis.x+wAxis.y+wAxis.z+sAxis.x+sAxis.y+sAxis.z);

vec3 camPos = (vec3(0.0, 0.0, -1.0));//*pi;
vec3 camUp  = (vec3(0.0,1.0,0.0));
float focus = 0.75;//pi+sin(t)*phi;
vec3 camTarget = oAxis*0.1;//vec3(0.0);

vec3 rotate(vec3 vec, vec3 axis, float ang)
{
    float cosang = cos(ang);
    return vec * cosang + cross(axis, vec) * sin(ang) + axis * dot(axis, vec) * (1.0 - cosang);
}



vec3 pin(vec3 v)
{
    vec3 q = vec3(0.0);
    v.zxy = sin((v.yzx+vec3(0.0,2.094395102,4.188790205)))*0.5+0.5; //change color range
    return (v);
}

vec3 spin(vec3 v)
{
    for(int i = 1; i <3; i++)
    {
        v=pin(rotate((v),pin(v),float(i*i)))*e;
    }
    return (v.xyz);
}

vec3 fin(vec3 v){

	vec4 vt = vec4(v,(v.x+v.y+v.z)/pi);
	vec4 vs = vt;
	vt.xyz  += pin(vs.xyz);
	vt.xyz  += pin(vs.yzw);
	vt.xyz  += pin(vs.zwx);
	vt.xyz  += pin(vs.wxy);
	return spin(vt.xyz/pisq);
}


vec3 sfin(vec3 v)
{
    for(int i = 1; i < 3; i++)
    {
        v =(v+fin(v*float(i)));
    }
    return (normalize((fin(v.zxy)))+(spin(v.zxy*rcpi)))/2.;
}



float hash( float n )
{
    return fract(sin(n)*43758.5453);
}
float noise( in vec3 x )
{
    vec3 p = floor(x);
    vec3 f = fract(x);

    f = f*f*(3.0-2.0*f);
    float n = p.x + p.y*57.0 + 113.0*p.z;
    return mix(mix(mix( hash(n+  0.0), hash(n+  1.0),f.x),
                   mix( hash(n+ 57.0), hash(n+ 58.0),f.x),f.y),
               mix(mix( hash(n+113.0), hash(n+114.0),f.x),
                   mix( hash(n+170.0), hash(n+171.0),f.x),f.y),f.z);
}

//x3
vec3 noise3( in vec3 x)
{
	return vec3( noise(x+vec3(123.456,.567,.37)),
				noise(x+vec3(.11,47.43,19.17)),
				noise(x) );
}

//http://dept-info.labri.fr/~schlick/DOC/gem2.ps.gz
float bias(float x, float b) {
	return  x/((1./b-2.)*(1.-x)+1.);
}

float gain(float x, float g) {
	float t = (1./g-2.)*(1.-(2.*x));	
	return x<0.5 ? (x/(t+1.)) : (t-x)/(t-1.);
}


mat3 rotation(float angle, vec3 axis)
{
    float s = sin(-angle);
    float c = cos(-angle);
    float oc = 1.0 - c;
	vec3 sa = axis * s;
	vec3 oca = axis * oc;
    return mat3(	
		oca.x * axis + vec3(	c,	-sa.z,	sa.y),
		oca.y * axis + vec3( sa.z,	c,		-sa.x),		
		oca.z * axis + vec3(-sa.y,	sa.x,	c));	
}

vec3 fbm(vec3 x, float H, float L, int oc)
{
	vec3 v = vec3(0);
	float f = 1.;
	for (int i=0; i<10; i++)
	{
		if (i >= oc) break;
		float w = pow(f,-H);
		v += noise3(x)*w;
		x *= L;
		f *= L;
	}
	return v;
}

vec3 smf(vec3 x, float H, float L, int oc, float off)
{
	vec3 v = vec3(1);
	float f = 1.;
	for (int i=0; i<10; i++)
	{
		if (i >= oc) break;
		v *= off + f*(noise3(x)*2.-1.);
		f *= H;
		x *= L;
	}
	return v;	
}


void main()
{

		float stages = 4.0;
	float stage =round(val1*(stages - 1.0));//mod(elapsedTime * .6, stages);// 0.; //

	if(stage < 1.) {



	vec3 uv =position*0.0004;//uvV.xy;// / uResolution.xy;
	uv.x *= normal.z*2.0;//position.y;// / gl_FragCoord.y;
//vec2 uv = normal.xy;
	//
	//vec2 uv = fragCoord.xy / iResolution.xy;
	//uv.x *= iResolution.x / iResolution.y;
	
	//float time = elapsedTime * 1.276 ;//* randomOffset
	
	float slow = elapsedTime*0.002;//* randomOffset*val2;
	uv *= 1. + .5*slow*sin(slow*1.);
	
	//float ts = time*0.07;
	float change =elapsedTime*0.5*0.1;//gain(fract(ts),0.008)+floor(ts);	//flick to a different view 
					//	+(abs(cos(elapsedTime))*4.0)
	//vec3 p = vec3(uv.yz*.8,slow+change);					//coordinate + slight change over time
	vec3 p = vec3(uv*.9);	
	vec3 axis = 4. * fbm(p, 0.5, 2., 8);				//random fbm axis of rotation
	
	vec3 colorVec = val4 * 5. * fbm(p*0.3,0.5,2.,7);		//random base color
	p += colorVec;
	
//	float mag = 4e5;	//published, rather garish?
	float mag = 0.75e5; //still clips a bit
	//mag = mag * (1.+sin(2.*3.1415927*elapsedTime)*0.75);
	vec3 colorMod = mag * smf(p,0.7,2.,8,.2);			//multifractal saturation
	colorVec += colorMod;
	
	colorVec = rotation(3.*length(axis)+slow+(cos(elapsedTime*0.1))*10.,normalize(axis))*colorVec;
	
	colorVec *= 0.05;
			
//	colorVec = colorVec / (1. + length(colorVec));	//tone it all down a bit
	
	colorVec = pow(colorVec,vec3(1./2.2));		//gamma
	gl_FragColor = vec4(colorVec,1.0);
}
 else if (stage < 2.){


	vec2 pos = position.yz*0.01*e;//(position.yz*0.01*e)*(sin(t*pi)-0.0);
	float ang = 1.0;//(sin(t*lnpi)*pi)+(distance(sAxis,wAxis)+distance(qAxis,sAxis)+distance(wAxis,qAxis));
	camPos = 1.0;//(camPos * cos(ang) + cross(qAxis, camPos) * sin(ang) + qAxis * dot(qAxis, camPos) * (1.0 - cos(ang)))*0.03*val3;
	
	vec3 camDir = normalize(camTarget);//normalize(camTarget-camPos);//camTarget
	camUp = 1.0;//rotate(camUp, camDir, sin(t*prpi)*pi);
    	vec3 camSide = 1.0;//cross(camDir, camUp);
	vec3 sideNorm=normalize(cross(camUp, camDir));
	vec3 upNorm=cross(camDir, sideNorm);
	vec3 worldFacing=(camPos + camDir);

    	vec3 rayDir = -normalize((worldFacing+sideNorm*pos.x + upNorm*pos.y - camDir*((focus*100.))));
	
	vec3 clr = vec3(0.0);

	vec3 vx = 1.0;//camPos;
	vec3 vt = 1.0;// vx;
	
	for(int i=1;i<15;i++) 
	{
		vx += (rayDir*float(i));
		vt = abs(sfin((vx*(cos(elapsedTime*0.1))+sAxis)*hfpi)-0.8)+0.1;
		clr = mix(clr*float(i)/pi,vt,e/(exp(abs(clr.x+clr.y+clr.z+vt.x+vt.y+0.0)*val4)));
	}

	clr = normalize(clr);
	
	
	gl_FragColor = vec4((clr),1.0);
 }
 else if (stage < 3.){

 vec3 v_texCoord =position*0.004;// gl_FragCoord.xy / resolution;
    // v_texCoord.x *= normal.z*0.01;
     vec3 p =  v_texCoord*0.4*val2 * 10.0 - vec3(10.0);
     vec2 i = p.xz ;//+p.x;
     
     float c = 5.0*100.0;
     
     float inten = 0.6;

     for (int n = 0; n < 10.0; n++) 
     {
          float t = (elapsedTime/5.0) * (1.0 - (3.0 / float(n+1)));
          
          i = p.xy + vec2(cos(t - i.x) + sin(t*2.0 + i.y),
                          sin(t - i.y) + cos(t + i.x));
                          
          c += 1.0/length(vec2(p.x / (sin(i.x + t)/inten),
                                    p.y / (cos(i.y+t)/inten)));
     }

     c /= float(10.0);
     c = c*0.002 - sqrt(c*0.02);

     //vec4 texColor = vec4( sin(i.x)/2.0, cos(i.x)/2.0, sin(i.y + p.y)/2.0, 1.0);
	vec4 textureColor = vec4( sin(i.x)/2.0, cos(i.x)/2.0, sin(i.y + p.z)/2.0, 1.0);
     //vec4 texColor = vec4(sin(time * p.x), cos(time), tan(0.30), 1.0);
     
     textureColor.r *= pow((1.0 / (1.0 - (c*0.4 + 0.0))), 0.1);
     textureColor.g *= pow((3.0 / (2.0 - (c*1.9 + 2.0))), 0.8);
     textureColor.b *= pow((1.0 / (1.0 - (c*3.6 + 2.0))), 0.8);
    // textureColor.rgb *= pow((1.0 / (1.0 - (c*1.0 + 0.0))), 0.8);
	
     
     gl_FragColor = val4 - textureColor;
 }

  else if (stage < 4.){
//abstract color

 	    bool glitch = true;//enables 'glitch' effect
    float time = elapsedTime*val2;
    
    /*Move and scale coordinate system*/
    vec2 offset = vec2(0.5*(sin(time/1.)+1.),0.5*(sin(time/3.)+1.));
    float scale = 100.*cos(time/25.)*cos(time/25.)+100.;
    float scale2 = 50.*cos(time/21.)*cos(time/21.)+2.;
	vec2 uv_temp = position.xz*0.0005*val3-offset*sin(time*(val2*0.0001)/scale)*scale2;;//(gl_FragCoord.xy / (resolution.xy)-offset)*sin(time/scale)*scale2;
    vec2 uv = vec2( uv_temp.y*sin(time/(scale*2.)),-uv_temp.x*cos(time/(scale*2.)));
    
    /*create 'phase-like' colour distributions*/
    float phib = (sin(time)*uv.y-cos(time)*uv.x)/(uv.x*uv.x+uv.y*uv.y)/2.0+0.5;
    float phir = (-sin(time)*uv.y-cos(time)*uv.x)/(uv.x*uv.x+uv.y*uv.y)/2.0+0.5;
    float phig = sin(time)*sin(time)*(sin(uv.x)/uv.x)*(sin(uv.x)/uv.x);
	
    /*modulate using sinusoidal functions*/
    vec4 result = 5.0*(vec4(phir,phig,phib,1)*sin(uv.x+time)+vec4(phir,phig,phib,1)*sin(uv.y-time))
        +sin(uv.x-3.0*time)*cos(uv.y+3.0*time)/2.0+0.5;
    
    /*add glitch effect*/
    float blend = sin(time/12.0)*sin(time/10.0*cos(time/3.0))*(1.0-(sin(uv.x-0.5)/(uv.x-0.5))*(sin(uv.x-0.5)/(uv.x-0.5)))*2.0;
    if( glitch && mod(uv.x+sin(time/10.0)*time/1000.0,sin(time)*sin(time)*0.05) < 0.01 && mod(uv.y+time/10.0,0.05+cos(time/2.0)/(time/2.0)) < 0.01 ) 
        result = vec4(1.0,1.0,1.0,1.0)*blend+result*(1.0-blend);
    
    
    result*=(result.x-(result.y+result.z))*(result.x-(result.y+result.z));
    
    /*insert bands into black and white regions*/
    if( result.x >1. && result.y >1. && result.z > 1. )
        result = vec4(1.,1.,1.,1)*(sin(uv.x));
    else if( result.x <0. && result.y <0. && result.z <0. )
    	result = sin(uv.y)*vec4(1.,1.,0.,1.)+cos(uv.y)*vec4(0.,0.,1.,0.);
    
    /*soften origin*/    
    result *= sqrt(uv.x*uv.x+uv.y*uv.y);
    
    gl_FragColor = result;
 }

gl_FragColor.a=alpha;

}