#include "scene1.h"

//--------------------------------------------------------------
scene1::scene1(){

}

//--------------------------------------------------------------
scene1::~scene1() {

}

//--------------------------------------------------------------
void scene1::setup() {
	fbo.allocate(200, 200, GL_RGB);
	shader.load("shader/curve");
}
void scene1::update( float val[5]) {

	shader.begin();
	shader.setUniform1f("elapsedTime", ofGetElapsedTimef());
	shader.setUniform2f("resolution",200,200);
	shader.setUniform1f("alpha", ofMap(255, 0, 255, 0.0, 1.0, true));
	for (int i = 0;i < 5;i++) {
		shader.setUniform1f("val" + ofToString(i), val[i]);
	}
	shader.end();
	//ofTexture tex = fbo.getTexture();

}

//--------------------------------------------------------------
void scene1::draw() {
	ofFill();
	ofSetColor(0,0,0);
	fbo.begin();
	shader.begin();
	ofDrawRectangle(0,0, 200, 200);
	shader.end();
	fbo.end();
	ofPixels pix;
	fbo.readToPixels(pix);
	ofMesh mesh;
	float extrusion = 100.0;
	int w = 200;
	int h = 200;
	for (int x = 0;x < w;x++) {
		for (int y = 0; y < h; y++)
		{
			int index = (x*w)+y;
			ofFloatColor col(pix.getColor(index*3));
			mesh.addVertex(ofVec3f(x, y, ofMap(col.getBrightness(), 0, 1.0, 0, extrusion)));
			mesh.addColor(col.getBrightness());
		}
	}

	for (int y = 0; y<h - 1; y++) {
		for (int x = 0; x<w - 1; x++) {
			mesh.addIndex(x + y* w);               // 0
			mesh.addIndex((x + 1) + y* w);           // 1
			mesh.addIndex(x + (y + 1)* w);           // 10

			mesh.addIndex((x + 1) + y* w);           // 1
			mesh.addIndex((x + 1) + (y + 1)* w);       // 11
			mesh.addIndex(x + (y + 1)* w);           // 10
		}
	}

	ofSetColor(255, 255, 255);
	ofEnableDepthTest();
	ofPushMatrix();
	ofScale(0.3, 0.3);
	ofTranslate(-100, -100);

	//SHADOW
	ofSetColor(0, 0, 0, 100);
	ofDrawRectangle(0, 0, 200, 200);
	ofSetColor(255, 255, 255,255);

	mesh.draw();

	ofPopMatrix();

	ofDisableDepthTest();
}