#include "scene2.h"

//--------------------------------------------------------------
scene2::scene2(){

}

//--------------------------------------------------------------
scene2::~scene2() {

}

//--------------------------------------------------------------
void scene2::setup() {
	//fbo.allocate(200, 200, GL_RGB);
	//shader.load("shader/curve");
	model.loadModel("3d/model.obj");
	shadow.load("shadow.png");


	// Point lights emit light in all directions //
	// set the diffuse color, color reflected from the light source //
	pointLight.setDiffuseColor(ofColor(0.f, 255.f, 0.f));

	// specular color, the highlight/shininess color //
	pointLight.setSpecularColor(ofColor(255.f, 255.f, 0.f));
	pointLight.setPointLight();



	spotLight.setDiffuseColor(ofColor(255.f, 0.f, 0.f));
	spotLight.setSpecularColor(ofColor(255.f, 255.f, 255.f));

	// turn the light into spotLight, emit a cone of light //
	spotLight.setSpotlight();

	// size of the cone of emitted light, angle between light axis and side of cone //
	// angle range between 0 - 90 in degrees //
	spotLight.setSpotlightCutOff(50);

	// rate of falloff, illumitation decreases as the angle from the cone axis increases //
	// range 0 - 128, zero is even illumination, 128 is max falloff //
	spotLight.setSpotConcentration(45);


	// Directional Lights emit light based on their orientation, regardless of their position //
	directionalLight.setDiffuseColor(ofColor(0.f, 0.f, 255.f));
	directionalLight.setSpecularColor(ofColor(255.f, 255.f, 255.f));
	directionalLight.setDirectional();

	// set the direction of the light
	// set it pointing from left to right -> //
	directionalLight.setOrientation(ofVec3f(0, 90, 0));

	// shininess is a value between 0 - 128, 128 being the most shiny //
	material.setShininess(120);
	// the light highlight of the material //
	material.setSpecularColor(ofColor(255, 255, 255, 255));
}

//--------------------------------------------------------------
void scene2::update(float val[5]) {
	pointLight.setPosition(cos(ofGetElapsedTimef()*.6f) * 40 * 2 ,
		sin(ofGetElapsedTimef()*.8f) * 40 * 2 ,
		-cos(ofGetElapsedTimef()*.8f) * 40 * 2 );

	spotLight.setOrientation(ofVec3f(0, cos(ofGetElapsedTimef()) * RAD_TO_DEG, 0));

}

//--------------------------------------------------------------
void scene2::draw() {
	ofEnableDepthTest();
	//
	ofEnableAlphaBlending();
	ofSetColor(255, 255, 255, 80);
	ofPushMatrix();
	ofTranslate(-75, -75);
	shadow.draw(0, 0, 150, 150);
	ofPopMatrix();
	ofFill();
	ofSetColor(255, 255, 255, 255);
	ofPushMatrix();
	ofScale(0.1, 0.1, 0.1);
	
	ofEnableLighting();
	light.enable();

	material.begin();
	// activate the lights //
 pointLight.enable();
 spotLight.enable();
 directionalLight.enable();
// ofDrawBox(40);
	model.drawFaces();
//	model.enableColors();
	//model.drawWireframe();
//	cout << "draw MODEL" << endl;

	light.disable();

 pointLight.disable();
 spotLight.disable();
 directionalLight.disable();

	material.end();
	ofDisableLighting();
	
	//ofSetLineWidth(3.0);
	//model.drawWireframe();
	//ofSetLineWidth(1.0);
	ofPopMatrix();

	ofDisableDepthTest();
}
